"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.default = handleNodemailer;
const fs_1 = __importDefault(require("fs"));
const nodemailer_1 = __importDefault(require("nodemailer"));
let transporter = nodemailer_1.default.createTransport({
    host: process.env.DSQL_MAIL_HOST,
    port: 465,
    secure: true,
    auth: {
        user: process.env.DSQL_MAIL_EMAIL,
        pass: process.env.DSQL_MAIL_PASSWORD,
    },
});
/**
 * # Handle mails With Nodemailer
 */
function handleNodemailer(_a) {
    return __awaiter(this, arguments, void 0, function* ({ to, subject, text, html, alias, senderName, }) {
        ////////////////////////////////////////
        ////////////////////////////////////////
        ////////////////////////////////////////
        if (!process.env.DSQL_MAIL_HOST ||
            !process.env.DSQL_MAIL_EMAIL ||
            !process.env.DSQL_MAIL_PASSWORD) {
            return null;
        }
        const sender = (() => {
            if (alias === null || alias === void 0 ? void 0 : alias.match(/support/i))
                return process.env.DSQL_MAIL_EMAIL;
            return process.env.DSQL_MAIL_EMAIL;
        })();
        ////////////////////////////////////////
        ////////////////////////////////////////
        ////////////////////////////////////////
        let sentMessage;
        if (!fs_1.default.existsSync("./email/index.html")) {
            return;
        }
        let mailRoot = fs_1.default.readFileSync("./email/index.html", "utf8");
        let finalHtml = mailRoot
            .replace(/{{email_body}}/, html ? html : "")
            .replace(/{{issue_date}}/, Date().substring(0, 24));
        ////////////////////////////////////////
        ////////////////////////////////////////
        ////////////////////////////////////////
        try {
            let mailObject = {};
            mailObject["from"] = `"${senderName || "Datasquirel"}" <${sender}>`;
            mailObject["sender"] = sender;
            if (alias)
                mailObject["replyTo"] = sender;
            mailObject["to"] = to;
            mailObject["subject"] = subject;
            mailObject["text"] = text;
            mailObject["html"] = finalHtml;
            // send mail with defined transport object
            let info = yield transporter.sendMail(mailObject);
            sentMessage = info;
            ////////////////////////////////////////
            ////////////////////////////////////////
            ////////////////////////////////////////
        }
        catch ( /** @type {any} */error) {
            ////////////////////////////////////////
            ////////////////////////////////////////
            ////////////////////////////////////////
            console.log("ERROR in handleNodemailer Function =>", error.message);
            // serverError({
            //     component: "handleNodemailer",
            //     message: error.message,
            //     user: { email: to },
            // });
        }
        return sentMessage;
    });
}
